Revit二次开发知识分享(十四) 选择轴网快速生成标注

  • 时间:
  • 浏览:
  • 来源:互联网

这次分享的是一个小功能。选择几根相互平行的轴网,然后快速生成标注,内容仅提供学习和参考,延展性很大,可自行开发。上代码Just Do It~~

            UIDocument uidoc = commandData.Application.ActiveUIDocument;
            Document doc = uidoc.Document;
            List<Reference> selRefList = uidoc.Selection.PickObjects(Autodesk.Revit.UI.Selection.ObjectType.Element).ToList();
            List<Grid> gridList = selRefList.Select(x => doc.GetElement(x)).OfType<Grid>().ToList();
            //其中一条轴网的定位线
            Line oneGridLocaLine = gridList[0].Curve as Line;
            //对轴网进行排列,先定个方向
            XYZ alignmentDirection = oneGridLocaLine.Direction.CrossProduct(XYZ.BasisZ);
            //确定一条排布的线
            Line tempLine = Line.CreateUnbound(oneGridLocaLine.GetEndPoint(0), alignmentDirection);
            //通过点乘去排列
            gridList = gridList.OrderBy(x => x.Curve.Evaluate(0.5, true).DotProduct(alignmentDirection)).ToList();
            Transaction trans = new Transaction(doc, "生成标注");
            trans.Start();
            //然后再遍历生成标注
            for (int i = 0; i < gridList.Count-1; i++)
            {
                Reference gridRef1 = new Reference(gridList[i]);
                Reference gridRef2 = new Reference(gridList[i+1]);
                ReferenceArray rerArr = new ReferenceArray();
                rerArr.Append(gridRef1);
                rerArr.Append(gridRef2);
                doc.Create.NewDimension(doc.ActiveView, tempLine, rerArr);
            }
            trans.Commit();
            return Result.Succeeded;

主要的流程为找到对应的Reference,然后再定位一条放置的横线,最终生成标注。
在这里插入图片描述
希望可以帮到你,如果能点赞支持,则是对我最大的鼓励,谢谢

本文链接http://www.dzjqx.cn/news/show-617109.html